#include <stdio.h>
#include "mpi.h"

int main(int argc, char** argv)
{
   int my_rank;  /* Rank of process */
   int p;        /* Number of processes */

   int namelen;
   char processor_name[MPI_MAX_PROCESSOR_NAME];

   int source;        /* Rank of sender */
   int dest=0;        /* Rank of receiver */
   int tag = 1;       /* Tag for messages */
   char message[100]; /* Storage for the message */
   MPI_Status status; /* Return status for receive */

   MPI_Init(&argc, &argv);
   MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
   MPI_Comm_size(MPI_COMM_WORLD, &p);
   MPI_Get_processor_name(processor_name, &namelen);

   if (my_rank != 0)
   {  /* Send a message to the root process */
      sprintf(message, "Hello World! Sent by rank %d of %d on %s", my_rank, p, processor_name);
      /* Use strlen(message)+1 to include '\0' */
      MPI_Send(message, strlen(message)+1, MPI_CHAR, dest, tag, MPI_COMM_WORLD);
   }
   else /* my_rank == 0 */
   {    /* Receive a message from each of the other processes */
      for (source = 1; source < p; source++)
      {
         MPI_Recv(message, 100, MPI_CHAR, source, tag, MPI_COMM_WORLD, &status);
         printf("%s\n", message);
      }
   }

   MPI_Finalize();
   return 0;
}
